#include "Person.h"
#include <algorithm>
#include <ios>
#include <iostream>
#include <fstream>
std::ostream& operator << (std::ostream& out, const Person& data) {
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		out << i->full_name << " " <<
			i->enrollment_date << " " <<
			i->personnel_number << " " <<
			i->department_number << " " <<
			i->salary << " " <<
			i->bonus_percentage << " " <<
			i->income_tax << " " <<
			i->number_of_days_worked << " " << std::endl;
	}
	return out;
}

std::istream& operator >> (std::istream& in, Person& data) {
	data = Person();
	while (true) {
		Person::Data d;
		in >> d.full_name;
		in >> d.enrollment_date;
		if (d.full_name == "\\0" && d.enrollment_date == "\\0" || d == Person::Data()) {
			data.cont.insert(Person::Data());
			break;
		}
		in >> d.personnel_number;
		in >> d.department_number;
		in >> d.salary;
		in >> d.bonus_percentage;
		in >> d.income_tax;
		in >> d.number_of_days_worked;
		data.cont.insert(d);
	}
	return in;
}

bool Person::operator == (const Person& data) {
	if (cont.size() != data.cont.size())
		return false;
	auto i = cont.begin();
	auto j = data.cont.begin();
	while (i != cont.end() && j != data.cont.end()) {
		if (*i != *j)
			return false;
		++i;
		++j;
	}
	return true;
}

void Person::add(std::ofstream& file) {
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		file.write((char*)&(*i), sizeof(Data));
	}
}

void Person::read(std::ifstream& file) {
	while (!file.eof()) {
		Person::Data d;
		file.read((char*)&d, sizeof(Data));
		cont.insert(d);
	}
}

void Person::create_file(std::ofstream& file) {
	Person data;
	std::cin >> data;
	data.add(file);
}

void Person::delete_data(std::ofstream& file_write, std::ifstream& file_read) {
	Person data;
	data.read(file_read);
	bool b = true;
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		if (b && !const_cast<Data&>(*i).in(this->cont))
			data.add(file_write);
		else
			b = false;
		if (!b)
			data.add(file_write);
	}
}

void Person::replacement(std::ofstream& file_write, std::ifstream& file_read, Person& data) {
	this->delete_data(file_write, file_read);
	data.add(file_write);
}

void Person::convert_to_txt(const std::string& filepath) {
	std::ofstream text(filepath);

	if (!text.is_open())
		throw std::runtime_error("File is not opened!");
	text << "------------Data about company employees<<------------\n";
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		text << "full name of person:" << i->full_name << '\n';
		text << "enrollment date:" << i->enrollment_date << '\n';
		text << "personnel number:" << i->personnel_number << '\n';
		text << "department number:" << i->department_number << '\n';
		text << "salary" << i->salary << '\n';
		text << "bonus percentage:" << i->bonus_percentage << '\n';
		text << "income tax:" << i->income_tax << '\n';
		text << "number of days worked:" << i->number_of_days_worked << '\n';
		text << "---------------------------------------------------\n";
	}
	text << "it's all data\n";
	text.close();

}
void Person::find_full_name(const std::string& p, std::ofstream& file)
{
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->full_name == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}

void Person::find_department_number(int p, std::ofstream& file)
{
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->department_number == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}

void Person::find_enrollment_date(const std::string& p, std::ofstream& file)
{
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->enrollment_date == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}